package com.inca.npbusi.sacon.bms_sa_con_backexec;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.util.SendHelper;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.pubsrv.Entrychose;
import java.awt.event.ActionListener;

public class Bms_sales_mde extends CMdeModelAp implements ActionListener {
   private String a = "";
   private String b = "";

   public String getEntryid() {
      return this.a;
   }

   public void setEntryid(String var1) {
      this.a = var1;
   }

   public String getEntryname() {
      return this.b;
   }

   public void setEntryname(String var1) {
      this.b = var1;
   }

   public Bms_sales_mde(CFrame var1, String var2) {
      super(var1, var2);
      this.setSaveimmdiate(true);
      this.setResetbeforenew(true);
      this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
      this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
   }

   protected CMasterModel createMastermodel() {
      return new Bms_sales_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Bms_sales_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "xinsalesid";
   }

   public String getDetailRelatecolname() {
      return "xinsalesid";
   }

   public String getSaveCommandString() {
      return "Bms_sales_mde.销售订单回退执行";
   }

   protected int on_actionPerformed(String var1) {
      if (var1.equals("回退执行")) {
         Bms_sales_mde var15 = this;
         RemotesqlHelper var2 = new RemotesqlHelper();
         int[] var3 = this.mastermodel.getTable().getSelectedRows();
         ClientRequest var4 = new ClientRequest();
         StringCommand var5 = null;
         var5 = new StringCommand("销售订单回退执行.回退");
         ParamCommand var6 = new ParamCommand();
         String var7 = null;
         var7 = null;
         String var8 = null;
         var7 = null;
         String var9 = null;
         String var10 = null;
         DBTableModel var11 = null;
         var9 = null;

         try {
            if (var3.length == 0) {
               var15.infoMessage("", "请选择单据，可以多选！");
            } else {
               int var12 = 0;

               while(true) {
                  if (var12 >= var3.length) {
                     var4.addCommand(var5);
                     var4.addCommand(var6);
                     var15.setWaitCursor();
                     StringCommand var16;
                     if ((var16 = (StringCommand)SendHelper.sendRequest(var4).commandAt(0)).getString().startsWith("+OK")) {
                        var15.infoMessage("提示", "回退完成！");

                        for(var12 = var15.detailmodel.getRowCount() - 1; var12 >= 0; --var12) {
                           var15.detailmodel.getDBtableModel().removeRow(var12);
                        }

                        for(var12 = var3.length - 1; var12 >= 0; --var12) {
                           var15.mastermodel.getDBtableModel().removeRow(var3[var12]);
                        }

                        var15.mastermodel.tableChanged();
                        var15.mastermodel.doRequery();
                        var15.setDefaultCursor();
                     } else {
                        var15.setDefaultCursor();
                        var15.infoMessage("提示", "回退执行时出错:" + var16.getString());
                     }
                     break;
                  }

                  var7 = var15.mastermodel.getItemValue(var3[var12], "comefrom");
                  var8 = var15.mastermodel.getItemValue(var3[var12], "salesid");
                  var10 = var15.mastermodel.getItemValue(var3[var12], "type");
                  if (var7.equals("1")) {
                     var15.infoMessage("提示", "请选择来源为\"订单生成\"发货单进行回退！");
                     break;
                  }

                  var9 = "select * from bms_sa_dtl where salesid = " + var8;
                  var11 = var2.doSelect(var9, 0, 2147483646);

                  for(int var13 = 0; var13 < var11.getRowCount(); ++var13) {
                     var7 = var11.getItemValue(var13, "salesdtlid");
                     var9 = "select * from bms_sa_dtl where salesid = " + var7;
                     var9 = var2.doSelect(var9, 0, 1).getItemValue(0, "sadtlidmodel");
                     var9 = "select * from bms_mv_dtl a,bms_mv_doc b where a.moveid = b.moveid and a.websourceid = " + var9;
                     DBTableModel var17;
                     if ((var17 = var2.doSelect(var9, 0, 1)) != null && var17.getRowCount() > 0 && (var9 = var17.getItemValue(0, "usestatus")) != null && var9.trim().length() > 0 && !"0".equals(var9)) {
                        var15.infoMessage("提示", "只有临时状态才可以回退");
                        return 0;
                     }

                     var9 = "select * from bms_st_io_doc_tmp where sourcetable = 2 and comefrom = 3 and sourceid=" + var7;
                     if (var2.doSelect(var9, 0, 999999).getRowCount() == 0) {
                        var9 = "select * from bms_st_io_doc where sourcetable = 2 and comefrom = 3 and sourceid=" + var7;
                        if (var2.doSelect(var9, 0, 999999).getRowCount() > 0) {
                           var15.infoMessage("提示", "发货单id为" + var8 + "的细单" + var7 + "已经出库记账，不允许回退！");
                           return 0;
                        }
                     }
                  }

                  var6.addParam("salesid" + var12, var8 + "," + var10);
                  ++var12;
               }
            }
         } catch (Exception var14) {
            this.infoMessage("提示", "回退执行时出错:" + var14.getMessage());
            var14.printStackTrace();
         }

         return 0;
      } else if (var1.equals("切换独立单元")) {
         if (this.mastermodel.getModifiedDbmodel().getRowCount() > 0) {
            this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
            return -1;
         } else {
            if (Entrychose.setUserEntryInfo(this.frame)) {
               this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
               this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
               this.getMasterModel().doRetrieve("1=2");
            }

            return 0;
         }
      } else {
         return super.on_actionPerformed(var1);
      }
   }
}
